package de.jatitv.commandguiv2.Spigot.config;

import de.jatitv.commandguiv2.Spigot.Main;
import net.t2code.lib.Spigot.Lib.messages.send;
import net.t2code.lib.Spigot.Lib.minecraftVersion.MCVersion;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.List;


public class DefaultGUICreate {
    public static void configCreate() {
        Long long_ = Long.valueOf(System.currentTimeMillis());
        send.console(Main.prefix + " §4Default GUI file (GUIs/default.yml) is loaded...");
        File config = new File(Main.getPath(), "GUIs/default.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

        set("GUI.Enable", true, yamlConfiguration);
        set("GUI.Lines", 1, yamlConfiguration);
        set("GUI.Name", "&5default &9GUI", yamlConfiguration);
        set("GUI.FillItem.Enable", true, yamlConfiguration);
        if (MCVersion.minecraft1_8 || MCVersion.minecraft1_9 || MCVersion.minecraft1_10 || MCVersion.minecraft1_11 || MCVersion.minecraft1_12) {
            set("GUI.FillItem.GlassPaneCollor", 15, yamlConfiguration);
        } else set("GUI.FillItem.Item", "BLACK_STAINED_GLASS_PANE", yamlConfiguration);

        set("Command.Alias", true, yamlConfiguration);
        set("Command.Permission.Required", true, yamlConfiguration);
        set("Slots.SupportDiscord.Slot", 4, yamlConfiguration);
        set("Slots.SupportDiscord.Enable", true, yamlConfiguration);
        set("Slots.SupportDiscord.Item.Empty", false, yamlConfiguration);
        set("Slots.SupportDiscord.Item.Amount", 1, yamlConfiguration);
        if (!(MCVersion.minecraft1_8 || MCVersion.minecraft1_9 || MCVersion.minecraft1_10 || MCVersion.minecraft1_11 || MCVersion.minecraft1_12)) {
            set("Slots.SupportDiscord.Item.PlayerHead.Enable", true, yamlConfiguration);
            set("Slots.SupportDiscord.Item.PlayerHead.Base64.Enable", true, yamlConfiguration);
            set("Slots.SupportDiscord.Item.PlayerHead.Base64.Base64Value", "eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvNzg3M2MxMmJmZmI1MjUxYTBiODhkNWFlNzVjNzI0N2NiMzlhNzVmZjFhODFjYmU0YzhhMzliMzExZGRlZGEifX19", yamlConfiguration);
            set("Slots.SupportDiscord.Item.PlayerHead.PlayerWhoHasOpenedTheGUI", false, yamlConfiguration);
            set("Slots.SupportDiscord.Item.PlayerHead.PlayerName", "", yamlConfiguration);
        }
        if (MCVersion.minecraft1_8 || MCVersion.minecraft1_9 || MCVersion.minecraft1_10 || MCVersion.minecraft1_11 || MCVersion.minecraft1_12) {
            set("Slots.SupportDiscord.Item.Material", "TNT", yamlConfiguration);
        } else set("Slots.SupportDiscord.Item.Material", "", yamlConfiguration);
        set("Slots.SupportDiscord.Item.Name", "&3Support Discord", yamlConfiguration);
        set("Slots.SupportDiscord.Item.Lore", Arrays.asList("&8-----------------", "&bIf you need help setting up the plugin,", "&bfeel free to contact me on the Suport Discord.",
                "&8-----------------", "&eIf you find any errors or bugs,", "&eplease contact me so I can fix them.", "&8-----------------", "&5Discord: §7http://dc.t2code.net"),
                yamlConfiguration);
        set("Slots.SupportDiscord.CustomSound.Enable", false, yamlConfiguration);
        set("Slots.SupportDiscord.CustomSound.NoSound", false, yamlConfiguration);
        set("Slots.SupportDiscord.CustomSound.Sound", "", yamlConfiguration);
        set("Slots.SupportDiscord.Cost.Enable", false, yamlConfiguration);
        set("Slots.SupportDiscord.Cost.Price", 0.0, yamlConfiguration);
        set("Slots.SupportDiscord.Command.Enable", false, yamlConfiguration);
        set("Slots.SupportDiscord.Command.BungeeCommand", false, yamlConfiguration);
        set("Slots.SupportDiscord.Command.CommandAsConsole", false, yamlConfiguration);
        set("Slots.SupportDiscord.Command.Command", Arrays.asList(), yamlConfiguration);
        set("Slots.SupportDiscord.ServerChange.Enable", false, yamlConfiguration);
        set("Slots.SupportDiscord.ServerChange.Server", "", yamlConfiguration);
        set("Slots.SupportDiscord.OpenGUI.Enable", false, yamlConfiguration);
        set("Slots.SupportDiscord.OpenGUI.GUI", "", yamlConfiguration);

        set("Slots.SupportDiscord.Toggle.Permission.Enable", false, yamlConfiguration);

        set("Slots.SupportDiscord.Toggle.Permission.Permission", "", yamlConfiguration);

        set("Slots.SupportDiscord.Toggle.UseItem.Enable", false, yamlConfiguration);

        set("Slots.SupportDiscord.Message.Enable", true, yamlConfiguration);
        set("Slots.SupportDiscord.Message.Message", Arrays.asList("&6You can find more information on Discord: &ehttp://dc.t2code.net"), yamlConfiguration);
        set("Slots.SupportDiscord.Permission.Required", false, yamlConfiguration);

        set("Slots.SupportDiscord.SetConfig.Enable", false, yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.File.Path", "", yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.Option.Path", "", yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.Option.Premat", "String", yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.Value.LeftClick.String", "", yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.Value.LeftClick.Boolean", false, yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.Value.LeftClick.Integer", 0, yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.Value.LeftClick.Double", 0.0, yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.Value.LeftClick.List", Arrays.asList(), yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.Value.RightClick.String", "", yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.Value.RightClick.Boolean", false, yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.Value.RightClick.Integer", 0, yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.Value.RightClick.Double", 0.0, yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.Value.RightClick.List", Arrays.asList(), yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.PluginReload.Enable", false, yamlConfiguration);
        set("Slots.SupportDiscord.SetConfig.PluginReload.Command", "", yamlConfiguration);

        set("Slots.UseItem.Slot", 6, yamlConfiguration);
        set("Slots.UseItem.Enable", true, yamlConfiguration);
        set("Slots.UseItem.Item.Empty", false, yamlConfiguration);
        set("Slots.UseItem.Item.Amount", 1, yamlConfiguration);
        if (!(MCVersion.minecraft1_8 || MCVersion.minecraft1_9 || MCVersion.minecraft1_10 || MCVersion.minecraft1_11 || MCVersion.minecraft1_12)) {
            set("Slots.UseItem.Item.PlayerHead.Enable", false, yamlConfiguration);
            set("Slots.UseItem.Item.PlayerHead.Base64.Enable", false, yamlConfiguration);
            set("Slots.UseItem.Item.PlayerHead.Base64.Base64Value", "", yamlConfiguration);
            set("Slots.UseItem.Item.PlayerHead.PlayerWhoHasOpenedTheGUI", false, yamlConfiguration);
            set("Slots.UseItem.Item.PlayerHead.PlayerName", "", yamlConfiguration);
        }
        if (MCVersion.minecraft1_8 || MCVersion.minecraft1_9 || MCVersion.minecraft1_10 || MCVersion.minecraft1_11 || MCVersion.minecraft1_12) {
            set("Slots.UseItem.Item.Material", "", yamlConfiguration);
        } else set("Slots.UseItem.Item.Material", "", yamlConfiguration);
        set("Slots.UseItem.Item.Name", "&6Toggle UseItem", yamlConfiguration);
        set("Slots.UseItem.Item.Lore", Arrays.asList("&bYou currently have the UseItem set to: %commandgui_useitem%"),
                yamlConfiguration);
        set("Slots.UseItem.CustomSound.Enable", false, yamlConfiguration);
        set("Slots.UseItem.CustomSound.NoSound", false, yamlConfiguration);
        set("Slots.UseItem.CustomSound.Sound", "", yamlConfiguration);
        set("Slots.UseItem.Cost.Enable", false, yamlConfiguration);
        set("Slots.UseItem.Cost.Price", 0.0, yamlConfiguration);
        set("Slots.UseItem.Command.Enable", false, yamlConfiguration);
        set("Slots.UseItem.Command.BungeeCommand", false, yamlConfiguration);
        set("Slots.UseItem.Command.CommandAsConsole", false, yamlConfiguration);
        set("Slots.UseItem.Command.Command", Arrays.asList(), yamlConfiguration);
        set("Slots.UseItem.ServerChange.Enable", false, yamlConfiguration);
        set("Slots.UseItem.ServerChange.Server", "", yamlConfiguration);
        set("Slots.UseItem.OpenGUI.Enable", false, yamlConfiguration);
        set("Slots.UseItem.OpenGUI.GUI", "", yamlConfiguration);

        set("Slots.UseItem.Toggle.Permission.Enable", false, yamlConfiguration);

        set("Slots.UseItem.Toggle.Permission.Permission", "", yamlConfiguration);

        set("Slots.UseItem.Toggle.UseItem.Enable", true, yamlConfiguration);

        set("Slots.UseItem.Message.Enable", true, yamlConfiguration);
        set("Slots.UseItem.Message.Message", Arrays.asList("&bYour UseItem was set to: %commandgui_useitem%&b."), yamlConfiguration);
        set("Slots.UseItem.Permission.Required", false, yamlConfiguration);

        set("Slots.UseItem.SetConfig.Enable", false, yamlConfiguration);
        set("Slots.UseItem.SetConfig.File.Path", "", yamlConfiguration);
        set("Slots.UseItem.SetConfig.Option.Path", "", yamlConfiguration);
        set("Slots.UseItem.SetConfig.Option.Premat", "String", yamlConfiguration);
        set("Slots.UseItem.SetConfig.Value.LeftClick.String", "", yamlConfiguration);
        set("Slots.UseItem.SetConfig.Value.LeftClick.Boolean", false, yamlConfiguration);
        set("Slots.UseItem.SetConfig.Value.LeftClick.Integer", 0, yamlConfiguration);
        set("Slots.UseItem.SetConfig.Value.LeftClick.Double", 0.0, yamlConfiguration);
        set("Slots.UseItem.SetConfig.Value.LeftClick.List", Arrays.asList(), yamlConfiguration);
        set("Slots.UseItem.SetConfig.Value.RightClick.String", "", yamlConfiguration);
        set("Slots.UseItem.SetConfig.Value.RightClick.Boolean", false, yamlConfiguration);
        set("Slots.UseItem.SetConfig.Value.RightClick.Integer", 0, yamlConfiguration);
        set("Slots.UseItem.SetConfig.Value.RightClick.Double", 0.0, yamlConfiguration);
        set("Slots.UseItem.SetConfig.Value.RightClick.List", Arrays.asList(), yamlConfiguration);
        set("Slots.UseItem.SetConfig.PluginReload.Enable", false, yamlConfiguration);
        set("Slots.UseItem.SetConfig.PluginReload.Command", "", yamlConfiguration);

        try {
            yamlConfiguration.save(config);
        } catch (IOException e) {
            e.printStackTrace();
        }
        send.console(Main.prefix + " §2Default GUI file (GUIs/default.yml) was loaded." + " §7- §e" + (System.currentTimeMillis() - long_.longValue()) + "ms");
    }

    private static void set(String path, String value, YamlConfiguration config) {
        if (!config.contains(path)) {
            config.set(path, value);
        }
    }

    private static void set(String path, Integer value, YamlConfiguration config) {
        if (!config.contains(path)) {
            config.set(path, value);
        }
    }

    private static void set(String path, Boolean value, YamlConfiguration config) {
        if (!config.contains(path)) {
            config.set(path, value);
        }
    }

    private static void set(String path, List value, YamlConfiguration config) {
        if (!config.contains(path)) {
            config.set(path, value);
        }
    }

    private static void set(String path, Double value, YamlConfiguration config) {
        if (!config.contains(path)) {
            config.set(path, value);
        }
    }
}
